/* 
 * File:   Main.C
 * Author: Stijn
 *
 * Created on 6 mei 2016, 21:54
 */

#include<xc.h>
#include <stdio.h>
#include <stdlib.h>
#include"global.h"
#include"analoog.h"

// CONFIG
#pragma config FOSC = INTRC_IO  // Oscillator Selection (INTRC with I/O function on OSC2/CLKOUT and 10 us startup time)
#pragma config WDTE = ON         // Watchdog Timer Enable  
#pragma config CP = ON          // Code Protection - User Program Memory (Code protection on)
#pragma config MCLRE = OFF      // Master Clear Enable (MCLR pin functions as I/O, MCLR internally tied to Vdd)
#pragma config IOSCFS = 8MHz    // Internal Oscillator Frequency Select (8 MHz INTOSC Speed)
#pragma config CPSW = ON        // Code Protection - Self Writable Memory 
#pragma config BOREN = OFF      // Brown-out Reset Enable (BOR Disabled)
#pragma config DRTEN = ON        // Device Reset Timer Enable 

char     PWM_Counter;
char    PWM_waarde;
char    LED_Counter;
char    LED_Loop;

int main() {
//    goto hier
//    hier:
    InitPic();

    int Temperatuur;
    float TempFloat;
    char Versterking, SetPoint, minTemp, maxTemp;

    while (1){
        //****************************************
        //minTemp = ADIn(3);
        //minTemp = minTemp / 2;
        //****************************************
        minTemp = 30;   
        //**************************************** 

        //****************************************
        //maxTemp = ADIn(7);
        //maxTemp = maxTemp / 2;
        //****************************************
        maxTemp = 80;   
        //**************************************** 

        Temperatuur = ADIn(6);
        if (Temperatuur > 20){
            Temperatuur = Temperatuur - 20;     // Offset sensor
            //Temperatuur = Temperatuur * 38;     // Calc to temp *100
            //Temperatuur = Temperatuur / 100;    // /100

            //Temperatuur = 50;
            
            if(Temperatuur > minTemp){
                //Fan moet gaan draaien

                //Versterkingsfactor berekenen
                if(maxTemp > minTemp){
                    Versterking = maxTemp - minTemp;
                    Versterking = 50 / Versterking; 
                }else{
                    Versterking = 0;
                }

                SetPoint = (Temperatuur - minTemp) * Versterking;
                SetPoint = SetPoint + 50;

            }else{
                //Uitgang uit
                SetPoint = 0;   
            }
            
        }else{
            //Bevroren
            SetPoint = 0;
        }

        if(SetPoint > 100){
            PWM_waarde = 100;
        }else{
            PWM_waarde = SetPoint;
        }

        for(char i = 0; i < 200; i++){  
            __delay_ms(1);
            //ClrWdt();
            //_asm ClrWdt  _endasm
            CLRWDT();
        }
//        LED = 1;
//        __delay_ms(200);
//        LED = 0;
        
        
        
    } 
}

void InitPic(){
    //Ports
    PORTA = 0;
    PORTB = 0;
    PORTC = 0;
    LED = 1;
    
              //76543210
    TRISA   = 0b00011000;
    TRISB   = 0b00000000;
    TRISC   = 0b00001100;

    ANSEL   = 0b11001000;

    CM1CON0bits.C1ON = 0;
    CM2CON0bits.C2ON = 0;
    OPACON           = 0;

    //AD converters
    AnaInit();
    
    for(char i = 0; i < 200; i++){  
          __delay_ms(1);
          //ClrWdt();
          //_asm ClrWdt  _endasm
          CLRWDT();
      }
    
    //Timer0   76543210
    OPTION = 0b10000000;

    //Interupts
    //          76543210
    INTCON1 = 0b00100000;
    INTCON0 = 0b11000001;
//    INTCONbits.T0IF = 0;

}


void interrupt   Timer0Interrupt  (void){

    //if(INTCONbits.T0IF == 1){
    //              76543210
    if((INTCON0 & 0b00100000) > 1){
        //Timer overflow
        //INTCONbits.T0IF = 0;
        INTCON0 = INTCON0 & 0b11011111;
        TMR0 = 128; //234;

        PWM_Counter ++;
        if(PWM_Counter > 100){
            PWM_Counter = 0;
        }
        if (PWM_Counter >= PWM_waarde){
            OutputFet = 0;
        }else{
            OutputFet = 1;
        } 
        
        LED_Counter ++;
        if(LED_Counter > 100){
            LED_Counter = 0;
            LED_Loop ++;
            if(LED_Loop > 100){
                LED_Loop = 0;
            }
        }
        if (LED_Loop >= PWM_waarde){
            LED = 0;
        }else{
        //if (LED_Counter > 1){
            LED = 1;
        } 
        
    }
}
